Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | List of all members
FileBundlePlugin Class Reference
Inheritance diagram for FileBundlePlugin:

## Public Slots
QString | version ()
int | loadObject (QString _filename)
bool | saveObject (int _objectId, QString _filename)

## Signals
void | openedFile (int _objectId)
void | addEmptyObject (DataType _type, int &_objectId)
void | deleteObject (int _objectId)
void | updatedObject (int _objectId, const UpdateType &_type)
void | log (QString _message)
void | log (Logtype _type, QString _message)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from FileInterface
virtual void | openedFile (int _id)
| This signal has to be emitted if an object has been loaded from a file. More...
Signals inherited from LoadSaveInterface
virtual void | save (int _id, QString _filename)
| Save object to a file. More...
virtual void | load (QString _filename, DataType _type, int &_id)
| Load object from file with a specific DataType. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ScriptInterface
virtual void | scriptInfo (QString _functionWithParameters)
| Emit this signal if a scriptable function is executed. More...
virtual void | getScriptingEngine (QScriptEngine *&_engine)
virtual void | executeScript (QString _script)
virtual void | getAvailableFunctions (QStringList &_functions)

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
DataType | supportedType ()
| Return your supported object type( e.g. DATA_TRIANGLE_MESH ) More...
QString | getSaveFilters ()
QString | getLoadFilters ()
QWidget * | saveOptionsWidget (QString)
QWidget * | loadOptionsWidget (QString)

## Private Slots
void | noguiSupported ()
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...
Private Slots inherited from FileInterface
virtual int | loadObject (QString _filename)=0
| Load an object from the given file. More...
virtual int | loadObject (QString _filename, DataType _type)
| Load an object from the given file. More...

## Private Member Functions
bool | addEmptyObjects (unsigned int _num, const DataType &_dataType, std::vector< int > &_objectIDs)
void | deleteObjects (std::vector< int > &_objectIDs)
bool | readImagelistFile (const char *_filename, std::vector< std::string > &_imagePaths)
void | readCameras (FILE *_file, const std::vector< int > &_cameraObjectIDs, SplatCloud_Cameras &_cameras)
void | readPoints (FILE *_file, const std::vector< int > &_cameraObjectIDs, SplatCloud &_splatCloud)
bool | readBundleFile (const char *_filename, SplatCloud &_splatCloud)
bool | writeBundleFile (const char *_filename, const SplatCloud &_splatCloud)
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from FileInterface
virtual | ~FileInterface ()
| Destructor.
virtual bool | saveObject (int _id, QString _filename)=0
| Save an object from the given file. More...
virtual bool | saveObjects (IdList _ids, QString _filename)
| Save multiple objects to one file. More...
Private Member Functions inherited from LoadSaveInterface
virtual | ~LoadSaveInterface ()
| Destructor.
virtual void | addEmptyObject (DataType _type, int &_id)
virtual void | copyObject (int _oldId, int &_newId)
virtual void | emptyObjectAdded (int _id)
| DEPRECATED HERE (Moved to Type Interface)! Emit this signal if an empty object has been created. More...
virtual void | deleteObject (int _id)
| Delete an object This signal can be called from any thread. . More...
virtual void | deleteAllObjects ()
| Delete all Objects. More...
virtual void | getAllFileFilters (QStringList &_filters)
| Get all file filters that are registered. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ScriptInterface
virtual | ~ScriptInterface ()
| Destructor.
virtual void | executeFileScript (QString _filename)
virtual void | getDescription (QString _function, QString &_description, QStringList &_parameters, QStringList &_descriptions)

## Detailed Description

Definition at line 78 of file FileBundle.hh.

## Member Function Documentation

## ◆ description()

QString FileBundlePlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 119 of file FileBundle.hh.

## ◆ getLoadFilters()

QString FileBundlePlugin::getLoadFilters | ( |  | ) |
| inline virtual

Return the Qt Filters for File dialogs when loading files (e.g. "Off files ( *.off )" )

Implements FileInterface.

Definition at line 126 of file FileBundle.hh.

## ◆ getSaveFilters()

QString FileBundlePlugin::getSaveFilters | ( |  | ) |
| inline virtual

Get the Qt Filters for Filedialogs when saving files (e.g. "Off files ( *.off )" )

Implements FileInterface.

Definition at line 125 of file FileBundle.hh.

## ◆ loadOptionsWidget()

QWidget * FileBundlePlugin::loadOptionsWidget | ( | QString | _currentFilter | ) |
| virtual

You can provide a special widget showing options for loading your file types depending on the current filter

_currentFilter: one filter from loadFilters

Return 0 when you don't need one

Implements FileInterface.

Definition at line 531 of file FileBundle.cc.

## ◆ name()

QString FileBundlePlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 118 of file FileBundle.hh.

## ◆ saveOptionsWidget()

QWidget * FileBundlePlugin::saveOptionsWidget | ( | QString | _currentFilter | ) |
| virtual

You can provide a special widget showing options for saving your file types depending on the current filter

_currentFilter: one filter from saveFilters

Return 0 when you don't need one

Implements FileInterface.

Definition at line 522 of file FileBundle.cc.

## ◆ supportedType()

DataType FileBundlePlugin::supportedType | ( |  | ) |
| inline virtual

Return your supported object type( e.g. DATA_TRIANGLE_MESH )

If you support multiple DataTypes you can combine them bitwise here. The function is used from the load and save code to check if your plugin can handle an object of a given dataType.

Implements FileInterface.

Definition at line 122 of file FileBundle.hh.

The documentation for this class was generated from the following files:

- PluginCollection-FilePlugins/Plugin-FileBundle/FileBundle.hh
- PluginCollection-FilePlugins/Plugin-FileBundle/FileBundle.cc